import { ElementRef, Input, Injectable, ViewChild } from '@angular/core';
import Prism from 'prismjs';
import * as _ from 'lodash-es';
export class PrismClass {
    constructor() {
        this.change = false;
        this.changed = false;
        this.async = false;
        this.callback = undefined;
        this.templateOptions = { interpolate: /{{([\s\S]+?)}}/g };
    }
    set code(value) {
        if (value) {
            if (typeof (value) === 'string') {
                this._code = value;
            }
            else {
                throw new Error(`Property \`code\` should be \`string\` instead of provided \`${typeof (value)}\``);
            }
        }
    }
    get code() {
        return this._code;
    }
    set language(value) {
        if (value) {
            if (typeof (value) === 'string') {
                this._language = value;
            }
            else {
                throw new Error(`Property \`language\` should be \`string\` instead of provided \`${typeof (value)}\``);
            }
        }
        else {
            throw new Error('Missing property `language`.');
        }
    }
    ;
    get language() {
        return this._language;
    }
    highlight(whenChangeIs = false) {
        if (this.change === whenChangeIs) {
            if (this.codeElementRef && this.codeElementRef instanceof ElementRef) {
                if (this.interpolation) {
                    if (this.code) {
                        this.interpolate(this.code);
                    }
                    else {
                        this.codeElementRef.nativeElement.innerHTML = this.interpolate(this.codeElementRef.nativeElement.innerHTML);
                    }
                }
                if (this.code) {
                    this.codeHighlighted = Prism.highlight((this.interpolation) ? this.codeInterpolated : this.code, Prism.languages[this.language]);
                    this.codeElementRef.nativeElement.innerHTML = this.codeHighlighted;
                }
                else {
                    Prism.highlightElement(this.codeElementRef.nativeElement, this.async, this.callback);
                }
                this.change = false;
                this.changed = true;
            }
        }
    }
    onChanges(propertyName, changes) {
        if (changes) {
            _.each(changes, (value, key) => {
                switch (key) {
                    case propertyName:
                        if (changes[key].currentValue !== changes[key].previousValue) {
                            this.change = true;
                        }
                        break;
                }
            });
        }
    }
    interpolate(string) {
        return this.codeInterpolated = _.template(string, this.templateOptions)(this.interpolation);
    }
}
PrismClass.decorators = [
    { type: Injectable },
];
PrismClass.ctorParameters = () => [];
PrismClass.propDecorators = {
    'async': [{ type: Input, args: ['async',] },],
    'callback': [{ type: Input, args: ['callback',] },],
    'code': [{ type: Input, args: ['code',] },],
    'language': [{ type: Input, args: ['language',] },],
    'interpolation': [{ type: Input, args: ['interpolation',] },],
    'codeElementRef': [{ type: ViewChild, args: ['codeElementRef',] },],
};
//# sourceMappingURL=prism.class.js.map