import { Component, ViewEncapsulation } from '@angular/core';
import { PrismClass } from './prism.class';
export class PrismComponent extends PrismClass {
    ngAfterViewChecked() {
        this.highlight(true);
        this.changed = false;
    }
    ngOnChanges(changes) {
        this.onChanges('language', changes);
        this.onChanges('code', changes);
        if (this.code) {
            this.highlight(true);
            if (this.callback && this.codeElementRef) {
                this.callback(this.codeElementRef.nativeElement);
            }
        }
    }
}
PrismComponent.decorators = [
    { type: Component, args: [{
                encapsulation: ViewEncapsulation.None,
                selector: 'prism-highlight',
                template: `<pre class="language-{{language}}" *ngIf="language">
  <code #codeElementRef class="language-{{language}}">
    <ng-content *ngIf="!code"></ng-content>
  </code>
</pre>`
            },] },
];
PrismComponent.ctorParameters = () => [];
//# sourceMappingURL=prism.component.js.map